#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
package Hotfix;
use strict;
@Hotfix::ISA = qw(CPIP);

sub pre_init {
    my $hotfix=shift;
    (undef,$hotfix->{hotfix},$hotfix->{padv})=split(/::/m,$hotfix->{class},3);
    ($hotfix->{version},$hotfix->{prod})=split(/_/m,$hotfix->{hotfix});
    return '';
}

# needs to be here instead of Rel.pm to set $hotfix->{arg}
sub define_hf_patches {
    #my ($hotfix,$pkgname,$platvers,$release,@patches)=(@_);
    my $hotfix=shift;
    $hotfix->rel->define_level_patches('hfpatches', $hotfix->{arg}, @_);
    $hotfix->define_hf_patches_list(@_);
    return 1;
}

# needs to leave a trace of what patches defined in this hotfix
# this info will help on postinstall/postremove of the hotfix
sub define_hf_patches_list {
    my ($hotfix,$pkgname,$platvers,$release,@patches)=(@_);
    $hotfix->{patches}||=[];
    for my $patch (@patches) {
        next if (!$patch);
        push (@{$hotfix->{patches}}, $patch) 
            unless (EDRu::inarr($patch, @{$hotfix->{patches}}));
    }
    return 1;
}

sub define_patches {
    my $hotfix=shift;
    EDR::die("define_patches undefined for patch $hotfix");
    return 1;
}

# remove these stubs if any can-based counting/execution is implemented
# integrate with perform_task_sys, if that is the best implementation method
sub precheck_sys { }
sub prestop_sys { }
sub preinstall_sys { }
sub postinstall_sys { }
sub poststart_sys { }

1;
