#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
package Proc;
use strict;
@Proc::ISA = qw(CPIP);

# auto set padv references for pkgname and pkgobj
sub pre_init {
    my $proc=shift;
    (undef,$proc->{proci},$proc->{padv})=split(/::/m,$proc->{class},3);
    return;
}

# common Proc subs and trace-only stubs for optional Proc subs

# determine if a proc should not be started based on external
# hardware or software dependencies or for any other reason
sub donotstart_sys { return $_[0]->{donotstart} }

# determine if a proc should not be stopped based on external
# hardware or software dependencies or for any other reason
sub donotstop_sys { return $_[0]->{donotstop} }

sub start_sys { return 1; }
sub stop_sys { return 1; }
sub start_failed_sys { };
sub stop_failed_sys { };
# e3875756 if user start vxconfigd manually,to set status and remove file install_db just like sub start_sys does
sub set_if_proc_running{ };

sub check_sys {
    my ($proc,$sys,$stage)=@_;
    return 1 unless (defined $stage);

    if ($stage =~ /start/m) {
        return 1;
    } elsif ($stage =~ /stop/m) {
        return 0;
    }
}

1;
