#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
use strict;

package Pkg::VRTSamf731::Common;
@Pkg::VRTSamf731::Common::ISA = qw(Pkg);

sub init_common {
    my $pkg=shift;
    $pkg->{pkg}='VRTSamf';
    $pkg->{name}=Msg::new("Asynchronous Monitoring Framework")->{msg};
    $pkg->{installonpatchupgrade}=1;
    $pkg->{stopprocs}= [ qw(amf731) ];
    $pkg->{startprocs}= [ qw(amf731) ];
    return;
}

package Pkg::VRTSamf731::AIX;
@Pkg::VRTSamf731::AIX::ISA = qw(Pkg::VRTSamf731::Common);

package Pkg::VRTSamf731::HPUX;
@Pkg::VRTSamf731::HPUX::ISA = qw(Pkg::VRTSamf731::Common);

package Pkg::VRTSamf731::Linux;
@Pkg::VRTSamf731::Linux::ISA = qw(Pkg::VRTSamf731::Common);

package Pkg::VRTSamf731::RHEL6x8664;
@Pkg::VRTSamf731::RHEL6x8664::ISA = qw(Pkg::VRTSamf731::Linux);

package Pkg::VRTSamf731::RHEL7x8664;
@Pkg::VRTSamf731::RHEL7x8664::ISA = qw(Pkg::VRTSamf731::Linux);

package Pkg::VRTSamf731::OL6x8664;
@Pkg::VRTSamf731::OL6x8664::ISA = qw(Pkg::VRTSamf731::RHEL6x8664);

package Pkg::VRTSamf731::OL7x8664;
@Pkg::VRTSamf731::OL7x8664::ISA = qw(Pkg::VRTSamf731::Linux);

package Pkg::VRTSamf731::CentOS6x8664;
@Pkg::VRTSamf731::CentOS6x8664::ISA = qw(Pkg::VRTSamf731::RHEL6x8664);

package Pkg::VRTSamf731::CentOS7x8664;
@Pkg::VRTSamf731::CentOS7x8664::ISA = qw(Pkg::VRTSamf731::Linux);

package Pkg::VRTSamf731::SLES11x8664;
@Pkg::VRTSamf731::SLES11x8664::ISA = qw(Pkg::VRTSamf731::Linux);

package Pkg::VRTSamf731::SLES12x8664;
@Pkg::VRTSamf731::SLES12x8664::ISA = qw(Pkg::VRTSamf731::Linux);


package Pkg::VRTSamf731::SunOS;
@Pkg::VRTSamf731::SunOS::ISA = qw(Pkg::VRTSamf731::Common);

sub init_plat {
    my $pkg=shift;
    $pkg->{smf}=['/var/svc/manifest/system/amf.xml', '/lib/svc/method/amf'];
    return;
}

sub preremove_sys {
    my ($pkg, $sys) = (@_);
    my $vcs = $pkg->prod('VCS731');
    $vcs->backup_smf_scripts_sys($sys,$pkg);
    return;
}

sub postremove_sys {
    my ($pkg, $sys) = (@_);
    my $vcs = $pkg->prod('VCS731');
    $vcs->restore_smf_scripts_sys($sys,$pkg);
    return;
}

1;
