#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
use strict;

package Pkg::VRTScavf731::Common;
@Pkg::VRTScavf731::Common::ISA = qw(Pkg);

sub init_common {
    my $pkg=shift;
    $pkg->{pkg}='VRTScavf';
    $pkg->{name}=Msg::new("Cluster Server Agents for Cluster File System")->{msg};
    #$pkg->{startprocs}=[ qw(cavf51) ];
    #$pkg->{stopprocs}=[ qw(cavf51) ];
    $pkg->{unkernelpkg}=1;
    return;
}

package Pkg::VRTScavf731::AIX;
@Pkg::VRTScavf731::AIX::ISA = qw(Pkg::VRTScavf731::Common);

package Pkg::VRTScavf731::HPUX;
@Pkg::VRTScavf731::HPUX::ISA = qw(Pkg::VRTScavf731::Common);

package Pkg::VRTScavf731::Linux;
@Pkg::VRTScavf731::Linux::ISA = qw(Pkg::VRTScavf731::Common);

sub preinstall_sys {
     my ($pkg,$sys)= @_;
     $pkg->{iopt}='--force' if ($sys->pkgvers('VRTSvcstc'));
     return 1;
}

package Pkg::VRTScavf731::RHEL6x8664;
@Pkg::VRTScavf731::RHEL6x8664::ISA = qw(Pkg::VRTScavf731::Linux);

sub init_padv {
    my $pkg=shift;
    $pkg->{oslibs}{all}={
		"/bin/ksh" => "ksh.x86_64", 
		"libcrypt.so.1()(64bit)" => "glibc.x86_64",
		"libc.so.6()(64bit)" => "glibc.x86_64",
		"libc.so.6(GLIBC_2.2.5)(64bit)" => "glibc.x86_64",
		"libnsl.so.1()(64bit)" => "glibc.x86_64",
		"libpthread.so.0()(64bit)" => "glibc.x86_64",
		"libpthread.so.0(GLIBC_2.2.5)(64bit)" => "glibc.x86_64",
		"libstdc++.so.6()(64bit)" => "libstdc++.x86_64",
		"libstdc++.so.6(CXXABI_1.3)(64bit)" => "libstdc++.x86_64",
		"perl(Exporter)" => "perl.x86_64",
		"perl(Fcntl)" => "perl.x86_64",
		"perl(POSIX)" => "perl.x86_64",
		"perl(Socket)" => "perl.x86_64",
		"perl(strict)" => "perl.x86_64",
		"perl(warnings)" => "perl.x86_64",
		"rtld(GNU_HASH)" => "glibc.x86_64", 
	};
	return;
}

package Pkg::VRTScavf731::RHEL7x8664;
@Pkg::VRTScavf731::RHEL7x8664::ISA = qw(Pkg::VRTScavf731::Linux);

sub init_padv {
    my $pkg=shift;
    $pkg->{oslibs}{all}={
		"/bin/ksh" => "ksh.x86_64",
		"libcrypt.so.1()(64bit)" => "glibc.x86_64",
		"libc.so.6()(64bit)" => "glibc.x86_64",
		"libc.so.6(GLIBC_2.2.5)(64bit)" => "glibc.x86_64",
		"libgcc_s.so.1()(64bit)" => "libgcc.x86_64",
		"libgcc_s.so.1(GCC_3.0)(64bit)" => "libgcc.x86_64",
		"libnsl.so.1()(64bit)" => "glibc.x86_64",
		"libpthread.so.0()(64bit)" => "glibc.x86_64",
		"libpthread.so.0(GLIBC_2.2.5)(64bit)" => "glibc.x86_64",
		"libstdc++.so.6()(64bit)" => "libstdc++.x86_64",
		"libstdc++.so.6(CXXABI_1.3)(64bit)" => "libstdc++.x86_64",
		"perl(Exporter)" => "perl-Exporter.noarch",
		"perl(Fcntl)" => "perl.x86_64",
		"perl(POSIX)" => "perl.x86_64",
		"perl(Socket)" => "perl-Socket.x86_64",
		"perl(strict)" => "perl.x86_64",
		"perl(warnings)" => "perl.x86_64",
		"rtld(GNU_HASH)" => "glibc.x86_64",
	};
	return;
}

package Pkg::VRTScavf731::OL6x8664;
@Pkg::VRTScavf731::OL6x8664::ISA = qw(Pkg::VRTScavf731::RHEL6x8664);

package Pkg::VRTScavf731::OL7x8664;
@Pkg::VRTScavf731::OL7x8664::ISA = qw(Pkg::VRTScavf731::RHEL7x8664);

package Pkg::VRTScavf731::CentOS6x8664;
@Pkg::VRTScavf731::CentOS6x8664::ISA = qw(Pkg::VRTScavf731::RHEL6x8664);

package Pkg::VRTScavf731::CentOS7x8664;
@Pkg::VRTScavf731::CentOS7x8664::ISA = qw(Pkg::VRTScavf731::RHEL7x8664);

package Pkg::VRTScavf731::SLES11x8664;
@Pkg::VRTScavf731::SLES11x8664::ISA = qw(Pkg::VRTScavf731::Linux);

sub init_padv {
    my $pkg=shift;
	$pkg->{oslibs}{all}={
		"/bin/ksh" => "ksh.x86_64",
		"libcrypt.so.1()(64bit)" => "glibc.x86_64",
		"libc.so.6()(64bit)" => "glibc.x86_64",
		"libc.so.6(GLIBC_2.2.5)(64bit)" => "glibc.x86_64",
		"libnsl.so.1()(64bit)" => "glibc.x86_64",
		"libpthread.so.0()(64bit)" => "glibc.x86_64",
		"libpthread.so.0(GLIBC_2.2.5)(64bit)" => "glibc.x86_64",
		"libstdc++.so.6()(64bit)" => "libstdc++6.x86_64",
		"libstdc++.so.6(CXXABI_1.3)(64bit)" => "libstdc++6.x86_64",
	};
	return;
}

package Pkg::VRTScavf731::SLES12x8664;
@Pkg::VRTScavf731::SLES12x8664::ISA = qw(Pkg::VRTScavf731::Linux);

sub init_padv {
    my $pkg=shift;
    $pkg->{oslibs}{all}={
		"/bin/ksh" => "mksh.x86_64",
		"libcrypt.so.1()(64bit)" => "glibc.x86_64",
		"libc.so.6()(64bit)" => "glibc.x86_64",
		"libc.so.6(GLIBC_2.2.5)(64bit)" => "glibc.x86_64",
		"libnsl.so.1()(64bit)" => "glibc.x86_64",
		"libpthread.so.0()(64bit)" => "glibc.x86_64",
		"libpthread.so.0(GLIBC_2.2.5)(64bit)" => "glibc.x86_64",
	};
	return;
}


package Pkg::VRTScavf731::SunOS;
@Pkg::VRTScavf731::SunOS::ISA = qw(Pkg::VRTScavf731::Common);

1;
