#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
use strict;

package Pkg::VRTScfs731::Common;
@Pkg::VRTScfs731::Common::ISA = qw(Pkg);

sub init_common {
    my $pkg=shift;
    $pkg->{pkg}='VRTScfs';
    $pkg->{name}=Msg::new("Infoscale Cluster File System components")->{msg};
    $pkg->{gavers}='7.4.0.000';
    $pkg->{startprocs}=[qw(vxglm731 vxgms731 odm731 vcsmm731)];
    $pkg->{stopprocs}=[qw(vcsmm731 odm731 vxgms731 vxglm731)];
    return;
}

package Pkg::VRTScfs731::AIX;
@Pkg::VRTScfs731::AIX::ISA = qw(Pkg::VRTScfs731::Common);

sub init_plat {
    my $pkg=shift;
    $pkg->{donotrmonupgrade}=1;
    return;
}

package Pkg::VRTScfs731::HPUX;
@Pkg::VRTScfs731::HPUX::ISA = qw(Pkg::VRTScfs731::Common);

sub init_plat {
    my $pkg=shift;
    $pkg->{donotrmonupgrade}=1;
    return;
}

package Pkg::VRTScfs731::Linux;
@Pkg::VRTScfs731::Linux::ISA = qw(Pkg::VRTScfs731::Common);

package Pkg::VRTScfs731::SunOS;
@Pkg::VRTScfs731::SunOS::ISA = qw(Pkg::VRTScfs731::Common);

sub init_plat {
    my $pkg=shift;
    $pkg->{donotrmonupgrade}=1;
    return;
}


1;
