#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
use strict;

package Pkg::VRTSdbac731::Common;
@Pkg::VRTSdbac731::Common::ISA = qw(Pkg);

sub init_common {
    my $pkg=shift;
    $pkg->{pkg}='VRTSdbac';
    $pkg->{name}=Msg::new("Oracle Real Application Cluster Support Package")->{msg};
    $pkg->{stopprocs}=[ qw(vcsmm731 lmx731) ];
    $pkg->{startprocs}=[ qw(vcsmm731 lmx731) ];
    $pkg->{extra_types} = ['/etc/VRTSvcs/conf/PrivNIC.cf',
                    '/etc/VRTSvcs/conf/MultiPrivNIC.cf',
                    '/etc/VRTSvcs/conf/OracleServiceTypes.cf',
                    '/etc/VRTSvcs/conf/CRSResource.cf',
                    '/etc/VRTSvcs/conf/CSSD.cf',
                    ];
    return;
}

package Pkg::VRTSdbac731::AIX;
@Pkg::VRTSdbac731::AIX::ISA = qw(Pkg::VRTSdbac731::Common);

sub init_plat {
    my $pkg=shift;
    $pkg->{previouspkgnames}=[ qw(VRTSdbac.rte) ];
    return;
}

package Pkg::VRTSdbac731::HPUX;
@Pkg::VRTSdbac731::HPUX::ISA = qw(Pkg::VRTSdbac731::Common);

package Pkg::VRTSdbac731::Linux;
@Pkg::VRTSdbac731::Linux::ISA = qw(Pkg::VRTSdbac731::Common);

sub init_plat {
    my $pkg=shift;
    $pkg->{startprocs}=EDRu::arrdel($pkg->{startprocs}, 'lmx731');
    $pkg->{stopprocs}=EDRu::arrdel($pkg->{stopprocs}, 'lmx731');
    return;
}

package Pkg::VRTSdbac731::SunOS;
@Pkg::VRTSdbac731::SunOS::ISA = qw(Pkg::VRTSdbac731::Common);

sub init_plat {
    my $pkg=shift;
    $pkg->{startprocs}=EDRu::arrdel($pkg->{startprocs}, 'lmx731');
    $pkg->{stopprocs}=EDRu::arrdel($pkg->{stopprocs}, 'lmx731');
    return;
}
1;
