#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
use strict;

package Pkg::VRTSfssdk731::Common;
@Pkg::VRTSfssdk731::Common::ISA = qw(Pkg);

sub init_common {
    my $pkg=shift;
    $pkg->{pkg}='VRTSfssdk';
    $pkg->{name}=Msg::new("File System Software Developer Kit")->{msg};
    return;
}

package Pkg::VRTSfssdk731::AIX;
@Pkg::VRTSfssdk731::AIX::ISA = qw(Pkg::VRTSfssdk731::Common);

package Pkg::VRTSfssdk731::HPUX;
@Pkg::VRTSfssdk731::HPUX::ISA = qw(Pkg::VRTSfssdk731::Common);

package Pkg::VRTSfssdk731::Linux;
@Pkg::VRTSfssdk731::Linux::ISA = qw(Pkg::VRTSfssdk731::Common);

package Pkg::VRTSfssdk731::RHEL6x8664;
@Pkg::VRTSfssdk731::RHEL6x8664::ISA = qw(Pkg::VRTSfssdk731::Linux);

sub init_padv {
    my $pkg=shift;
    $pkg->{oslibs}{'RHEL6.4'}={
        "libc.so.6"  =>  "glibc-2.12-1.107.el6.i686",
        "libc.so.6(GLIBC_2.0)"  =>  "glibc-2.12-1.107.el6.i686",
        "libc.so.6(GLIBC_2.1)"  =>  "glibc-2.12-1.107.el6.i686",
        "libc.so.6(GLIBC_2.2)"  =>  "glibc-2.12-1.107.el6.i686",
        "libdl.so.2"  =>  "glibc-2.12-1.107.el6.i686",
        "libdl.so.2(GLIBC_2.0)"  =>  "glibc-2.12-1.107.el6.i686",
        "libdl.so.2(GLIBC_2.1)"  =>  "glibc-2.12-1.107.el6.i686",
        "libpthread.so.0"  =>  "glibc-2.12-1.107.el6.i686",
        "libpthread.so.0(GLIBC_2.0)"  =>  "glibc-2.12-1.107.el6.i686",
        "libpthread.so.0(GLIBC_2.2)"  =>  "glibc-2.12-1.107.el6.i686",
        "rtld(GNU_HASH)"  =>  "glibc-2.12-1.107.el6.x86_64",
    };
    $pkg->{oslibs}{'RHEL6.5'}={
        "libc.so.6"  =>  "glibc-2.12-1.132.el6.i686",
        "libc.so.6(GLIBC_2.0)"  =>  "glibc-2.12-1.132.el6.i686",
        "libc.so.6(GLIBC_2.1)"  =>  "glibc-2.12-1.132.el6.i686",
        "libc.so.6(GLIBC_2.2)"  =>  "glibc-2.12-1.132.el6.i686",
        "libdl.so.2"  =>  "glibc-2.12-1.132.el6.i686",
        "libdl.so.2(GLIBC_2.0)"  =>  "glibc-2.12-1.132.el6.i686",
        "libdl.so.2(GLIBC_2.1)"  =>  "glibc-2.12-1.132.el6.i686",
        "libpthread.so.0"  =>  "glibc-2.12-1.132.el6.i686",
        "libpthread.so.0(GLIBC_2.0)"  =>  "glibc-2.12-1.132.el6.i686",
        "libpthread.so.0(GLIBC_2.2)"  =>  "glibc-2.12-1.132.el6.i686",
        "rtld(GNU_HASH)"  =>  "glibc-2.12-1.132.el6.x86_64",
    };
    $pkg->{oslibs}{'RHEL6.6'}={
        "libc.so.6"  =>  "glibc-2.12-1.149.el6.i686",
        "libc.so.6(GLIBC_2.0)"  =>  "glibc-2.12-1.149.el6.i686",
        "libc.so.6(GLIBC_2.1)"  =>  "glibc-2.12-1.149.el6.i686",
        "libc.so.6(GLIBC_2.2)"  =>  "glibc-2.12-1.149.el6.i686",
        "libdl.so.2"  =>  "glibc-2.12-1.149.el6.i686",
        "libdl.so.2(GLIBC_2.0)"  =>  "glibc-2.12-1.149.el6.i686",
        "libdl.so.2(GLIBC_2.1)"  =>  "glibc-2.12-1.149.el6.i686",
        "libpthread.so.0"  =>  "glibc-2.12-1.149.el6.i686",
        "libpthread.so.0(GLIBC_2.0)"  =>  "glibc-2.12-1.149.el6.i686",
        "libpthread.so.0(GLIBC_2.2)"  =>  "glibc-2.12-1.149.el6.i686",
        "rtld(GNU_HASH)"  =>  "glibc-2.12-1.149.el6.x86_64",
    };
    $pkg->{oslibs}{'RHEL6.7'}={
        "libc.so.6"  =>  "glibc-2.12-1.166.el6.i686",
        "libc.so.6(GLIBC_2.0)"  =>  "glibc-2.12-1.166.el6.i686",
        "libc.so.6(GLIBC_2.1)"  =>  "glibc-2.12-1.166.el6.i686",
        "libc.so.6(GLIBC_2.2)"  =>  "glibc-2.12-1.166.el6.i686",
        "libdl.so.2"  =>  "glibc-2.12-1.166.el6.i686",
        "libdl.so.2(GLIBC_2.0)"  =>  "glibc-2.12-1.166.el6.i686",
        "libdl.so.2(GLIBC_2.1)"  =>  "glibc-2.12-1.166.el6.i686",
        "libpthread.so.0"  =>  "glibc-2.12-1.166.el6.i686",
        "libpthread.so.0(GLIBC_2.0)"  =>  "glibc-2.12-1.166.el6.i686",
        "libpthread.so.0(GLIBC_2.2)"  =>  "glibc-2.12-1.166.el6.i686",
        "rtld(GNU_HASH)"  =>  "glibc-2.12-1.166.el6.x86_64",
    };
    for my $minorvers (keys %{$pkg->{oslibs}}) {
        if ($minorvers=~/RHEL(.*)/) {
            $pkg->{oslibs}{"OL$1"} = { %{$pkg->{oslibs}{$minorvers}} };
        }
    }
    return;
}

package Pkg::VRTSfssdk731::RHEL7x8664;
@Pkg::VRTSfssdk731::RHEL7x8664::ISA = qw(Pkg::VRTSfssdk731::Linux);

sub init_padv {
    my $pkg=shift;
    $pkg->{oslibs}{'RHEL7.0'}={
        "libc.so.6"  =>  "glibc-2.17-55.el7.i686",
        "libc.so.6(GLIBC_2.0)"  =>  "glibc-2.17-55.el7.i686",
        "libc.so.6(GLIBC_2.1)"  =>  "glibc-2.17-55.el7.i686",
        "libc.so.6(GLIBC_2.2)"  =>  "glibc-2.17-55.el7.i686",
        "libdl.so.2"  =>  "glibc-2.17-55.el7.i686",
        "libdl.so.2(GLIBC_2.0)"  =>  "glibc-2.17-55.el7.i686",
        "libdl.so.2(GLIBC_2.1)"  =>  "glibc-2.17-55.el7.i686",
        "libpthread.so.0"  =>  "glibc-2.17-55.el7.i686",
        "libpthread.so.0(GLIBC_2.0)"  =>  "glibc-2.17-55.el7.i686",
        "libpthread.so.0(GLIBC_2.2)"  =>  "glibc-2.17-55.el7.i686",
        "rtld(GNU_HASH)"  =>  "glibc-2.17-55.el7.i686 glibc-2.17-55.el7.x86_64",
    };
    $pkg->{oslibs}{'RHEL7.1'}={
    };

    for my $minorvers (keys %{$pkg->{oslibs}}) {
        if ($minorvers=~/RHEL(.*)/) {
            $pkg->{oslibs}{"OL$1"} = { %{$pkg->{oslibs}{$minorvers}} };
        }
    }
    return;
}

package Pkg::VRTSfssdk731::OL6x8664;
@Pkg::VRTSfssdk731::OL6x8664::ISA = qw(Pkg::VRTSfssdk731::RHEL6x8664);

package Pkg::VRTSfssdk731::OL7x8664;
@Pkg::VRTSfssdk731::OL7x8664::ISA = qw(Pkg::VRTSfssdk731::RHEL7x8664);

package Pkg::VRTSfssdk731::CentOS6x8664;
@Pkg::VRTSfssdk731::CentOS6x8664::ISA = qw(Pkg::VRTSfssdk731::RHEL6x8664);

package Pkg::VRTSfssdk731::CentOS7x8664;
@Pkg::VRTSfssdk731::CentOS7x8664::ISA = qw(Pkg::VRTSfssdk731::RHEL7x8664);

package Pkg::VRTSfssdk731::SLES11x8664;
@Pkg::VRTSfssdk731::SLES11x8664::ISA = qw(Pkg::VRTSfssdk731::Linux);

sub init_padv {
    my $pkg=shift;
    $pkg->{oslibs}{SLES11SP3}={
        "libc.so.6"  =>  "glibc-32bit-2.11.3-17.54.1.x86_64",
        "libc.so.6(GLIBC_2.0)"  =>  "glibc-32bit-2.11.3-17.54.1.x86_64",
        "libc.so.6(GLIBC_2.1)"  =>  "glibc-32bit-2.11.3-17.54.1.x86_64",
        "libc.so.6(GLIBC_2.2)"  =>  "glibc-32bit-2.11.3-17.54.1.x86_64",
        "libdl.so.2"  =>  "glibc-32bit-2.11.3-17.54.1.x86_64",
        "libdl.so.2(GLIBC_2.0)"  =>  "glibc-32bit-2.11.3-17.54.1.x86_64",
        "libdl.so.2(GLIBC_2.1)"  =>  "glibc-32bit-2.11.3-17.54.1.x86_64",
        "libpthread.so.0"  =>  "glibc-32bit-2.11.3-17.54.1.x86_64",
        "libpthread.so.0(GLIBC_2.0)"  =>  "glibc-32bit-2.11.3-17.54.1.x86_64",
        "libpthread.so.0(GLIBC_2.2)"  =>  "glibc-32bit-2.11.3-17.54.1.x86_64",
    };
    return;
}

package Pkg::VRTSfssdk731::SLES12x8664;
@Pkg::VRTSfssdk731::SLES12x8664::ISA = qw(Pkg::VRTSfssdk731::Linux);

sub init_padv {
    my $pkg=shift;
    $pkg->{oslibs}{'SLES12SP0'}={
        "libc.so.6"  =>  "glibc-32bit-2.19-17.72.x86_64",
        "libc.so.6(GLIBC_2.0)"  =>  "glibc-32bit-2.19-17.72.x86_64",
        "libc.so.6(GLIBC_2.1)"  =>  "glibc-32bit-2.19-17.72.x86_64",
        "libc.so.6(GLIBC_2.2)"  =>  "glibc-32bit-2.19-17.72.x86_64",
        "libdl.so.2"  =>  "glibc-32bit-2.19-17.72.x86_64",
        "libdl.so.2(GLIBC_2.0)"  =>  "glibc-32bit-2.19-17.72.x86_64",
        "libdl.so.2(GLIBC_2.1)"  =>  "glibc-32bit-2.19-17.72.x86_64",
        "libpthread.so.0"  =>  "glibc-32bit-2.19-17.72.x86_64",
        "libpthread.so.0(GLIBC_2.0)"  =>  "glibc-32bit-2.19-17.72.x86_64",
        "libpthread.so.0(GLIBC_2.2)"  =>  "glibc-32bit-2.19-17.72.x86_64",
    };
    return;
}

package Pkg::VRTSfssdk731::SunOS;
@Pkg::VRTSfssdk731::SunOS::ISA = qw(Pkg::VRTSfssdk731::Common);

1;
