#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
use strict;

package Pkg::VRTSglm731::Common;
@Pkg::VRTSglm731::Common::ISA = qw(Pkg);

sub init_common {
    my $pkg=shift;
    $pkg->{pkg}='VRTSglm';
    $pkg->{name}=Msg::new("Group Lock Manager")->{msg};

    $pkg->{startprocs}=[ qw(vxglm731) ];
    $pkg->{stopprocs}=[ qw(vxglm731) ];
    return;
}

package Pkg::VRTSglm731::AIX;
@Pkg::VRTSglm731::AIX::ISA = qw(Pkg::VRTSglm731::Common);

package Pkg::VRTSglm731::HPUX;
@Pkg::VRTSglm731::HPUX::ISA = qw(Pkg::VRTSglm731::Common);

package Pkg::VRTSglm731::Linux;
@Pkg::VRTSglm731::Linux::ISA = qw(Pkg::VRTSglm731::Common);

package Pkg::VRTSglm731::RHEL6x8664;
@Pkg::VRTSglm731::RHEL6x8664::ISA = qw(Pkg::VRTSglm731::Linux);

sub init_padv {
    my $pkg=shift;
    $pkg->{oslibs}{all}={
		"libc.so.6()(64bit)" => "glibc.x86_64",
		"libc.so.6(GLIBC_2.2.5)(64bit)" => "glibc.x86_64",
		"libc.so.6(GLIBC_2.7)(64bit)" => "glibc.x86_64",
		"rtld(GNU_HASH)" => "glibc.x86_64",
	};
	return;
}

package Pkg::VRTSglm731::RHEL7x8664;
@Pkg::VRTSglm731::RHEL7x8664::ISA = qw(Pkg::VRTSglm731::Linux);

sub init_padv {
    my $pkg=shift;
	$pkg->{oslibs}{all}={
		"libc.so.6()(64bit)" => "glibc.x86_64",
		"libc.so.6(GLIBC_2.2.5)(64bit)" => "glibc.x86_64",
		"libc.so.6(GLIBC_2.7)(64bit)" => "glibc.x86_64",
		"rtld(GNU_HASH)" => "glibc.x86_64", 
	};
    return;
}

package Pkg::VRTSglm731::OL6x8664;
@Pkg::VRTSglm731::OL6x8664::ISA = qw(Pkg::VRTSglm731::RHEL6x8664);

package Pkg::VRTSglm731::OL7x8664;
@Pkg::VRTSglm731::OL7x8664::ISA = qw(Pkg::VRTSglm731::RHEL7x8664);

package Pkg::VRTSglm731::CentOS6x8664;
@Pkg::VRTSglm731::CentOS6x8664::ISA = qw(Pkg::VRTSglm731::RHEL6x8664);

package Pkg::VRTSglm731::CentOS7x8664;
@Pkg::VRTSglm731::CentOS7x8664::ISA = qw(Pkg::VRTSglm731::RHEL7x8664);

package Pkg::VRTSglm731::SLES11x8664;
@Pkg::VRTSglm731::SLES11x8664::ISA = qw(Pkg::VRTSglm731::Linux);

sub init_padv {
    my $pkg=shift;
	$pkg->{oslibs}{all}={
		"libc.so.6()(64bit)" => "glibc.x86_64",
		"libc.so.6(GLIBC_2.2.5)(64bit)" => "glibc.x86_64",
		"libc.so.6(GLIBC_2.7)(64bit)" => "glibc.x86_64",
	};
    return;
}

package Pkg::VRTSglm731::SLES12x8664;
@Pkg::VRTSglm731::SLES12x8664::ISA = qw(Pkg::VRTSglm731::Linux);

sub init_padv {
    my $pkg=shift;
    $pkg->{oslibs}{all}={
		"libc.so.6()(64bit)" => "glibc.x86_64",
		"libc.so.6(GLIBC_2.2.5)(64bit)" => "glibc.x86_64",
		"libc.so.6(GLIBC_2.7)(64bit)" => "glibc.x86_64",
	};
	return;
}

package Pkg::VRTSglm731::SunOS;
@Pkg::VRTSglm731::SunOS::ISA = qw(Pkg::VRTSglm731::Common);

sub init_plat {
    my $pkg=shift;
    $pkg->{donotrmonupgrade}=0;
    return;
}

1;
