#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
use strict;

package Pkg::VRTSperl520::Common;
@Pkg::VRTSperl520::Common::ISA = qw(Pkg);

sub init_common {
    my $pkg=shift;
    $pkg->{pkg}='VRTSperl';
    $pkg->{name}=Msg::new("Perl Redistribution")->{msg};
    $pkg->{gavers}='5.20.1.3';
    return;
}

#Add dependency for other products only when uninstall VRTSperl
sub query_pkgdep_sys {
    my ($pkg,$sys)=@_;
    my (@softdeps,$vxvm,$vxfs,$vcs,$rel);
    $rel=Obj::rel();
    if (Cfg::opt('uninstall')) {
        push (@softdeps,'VRTScmcm') if ($sys->pkgvers('VRTScmcm'));
        push (@softdeps,'VRTSccsta.ccsta') if ($sys->pkgvers('VRTSccsta.ccsta'));
        push (@softdeps,'VRTSccsta') if ($sys->pkgvers('VRTSccsta'));
        push (@softdeps,'VRTShalR') if ($sys->pkgvers('VRTShalR'));
        push (@softdeps,'VRTSccsts') if ($sys->pkgvers('VRTSccsts'));
        push (@softdeps,'VRTSccer') if ($sys->pkgvers('VRTSccer'));
        $vxvm = $sys->pkg('VRTSvxvm731') if (EDRu::inarr("VM731",@{$rel->{prods}}));
        $vxfs = $sys->pkg('VRTSvxfs731') if (EDRu::inarr("FS731",@{$rel->{prods}}));
        $vcs = $sys->pkg('VRTSvcs731') if (EDRu::inarr("VCS731",@{$rel->{prods}}));
        push (@softdeps, $vxvm->{pkg}) if ($vxvm && $vxvm->version_sys($sys));
        push (@softdeps, $vxfs->{pkg}) if ($vxfs && $vxfs->version_sys($sys));
        push (@softdeps, $vcs->{pkg}) if ($vcs && $vcs->version_sys($sys));
        return \@softdeps;
    }
    return [];
}

package Pkg::VRTSperl520::AIX;
@Pkg::VRTSperl520::AIX::ISA = qw(Pkg::VRTSperl520::Common);

sub init_plat {
    my $pkg=shift;
    $pkg->{donotrmonupgrade}=1;
    $pkg->{previouspkgnames}=[ qw(VRTSperl.rte) ];
    return;
}

package Pkg::VRTSperl520::HPUX;
@Pkg::VRTSperl520::HPUX::ISA = qw(Pkg::VRTSperl520::Common);

sub init_plat {
    my $pkg=shift;
    $pkg->{donotrmonupgrade}=1;
    return;
}

package Pkg::VRTSperl520::Linux;
@Pkg::VRTSperl520::Linux::ISA = qw(Pkg::VRTSperl520::Common);

package Pkg::VRTSperl520::SunOS;
@Pkg::VRTSperl520::SunOS::ISA = qw(Pkg::VRTSperl520::Common);

sub init_plat {
    my $pkg=shift;
    $pkg->{donotrmonupgrade}=1;
    return;
}

1;
