#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
use strict;

package Pkg::VRTSsvs731::Common;
@Pkg::VRTSsvs731::Common::ISA = qw(Pkg);

sub donotinstall_sys {
    my ($pkg,$sys) = @_;
    my ($pkgsys);

    $pkgsys = Obj::pkg($pkg->{pkgi},$sys->{padv},1);
    if (!$pkgsys) {
        $pkgsys = $pkg;
    }
    return $pkgsys->{donotinstall} || EDRu::inarr($pkgsys->{pkgi},@{$sys->{donotinstallpkgs}});
}

sub douninstall_sys {
    my ($pkg,$sys) = @_;
    my ($pkgsys);

    $pkgsys = Obj::pkg($pkg->{pkgi},$sys->{padv},1);
    if (!$pkgsys) {
        $pkgsys = $pkg;
    }
    return $pkgsys->{douninstall} || EDRu::inarr($pkgsys->{pkgi},@{$sys->{donotuninstallpkgs}});
}

sub donotupgrade_sys {
    my ($pkg,$sys) = @_;
    my ($pkgsys);

    $pkgsys = Obj::pkg($pkg->{pkgi},$sys->{padv},1);
    if (!$pkgsys) {
        $pkgsys = $pkg;
    }
    return $pkgsys->{donotupgrade} || EDRu::inarr($pkgsys->{pkgi},@{$sys->{donotupgradepkgs}});
}

sub init_common {
    my $pkg=shift;
    $pkg->{pkg}='VRTSsvs';
    $pkg->{donotinstall}=1;
    $pkg->{douninstall}=1;
    $pkg->{donotupgrade}=1;
    $pkg->{name}=Msg::new("VirtualStore")->{msg};
    $pkg->{startprocs}=[ qw() ];
    $pkg->{stopprocs}=[ qw(svsweb731) ];
    return;
}

package Pkg::VRTSsvs731::AIX;
@Pkg::VRTSsvs731::AIX::ISA = qw(Pkg::VRTSsvs731::Common);

package Pkg::VRTSsvs731::HPUX;
@Pkg::VRTSsvs731::HPUX::ISA = qw(Pkg::VRTSsvs731::Common);

package Pkg::VRTSsvs731::Linux;
@Pkg::VRTSsvs731::Linux::ISA = qw(Pkg::VRTSsvs731::Common);

sub init_plat {
    my $pkg=shift;
    $pkg->{nodeps}=1;
    return;
}

package Pkg::VRTSsvs731::SunOS;
@Pkg::VRTSsvs731::SunOS::ISA = qw(Pkg::VRTSsvs731::Common);

1;
