#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
use strict;

package Pkg::VRTSvcsk731::Common;
@Pkg::VRTSvcsk731::Common::ISA = qw(Pkg);

sub init_common {
    my $pkg=shift;
    $pkg->{pkg}='VRTSvcsk';
    $pkg->{name}=Msg::new("Infoscale Cluster components")->{msg};
    $pkg->{gavers}='7.4.0.000';
    $pkg->{startprocs}=[ qw(llt731 gab731 vxfen731 amf731) ];
    $pkg->{stopprocs}=[ qw(amf731 vxfen731 gab731 llt731) ];
    return;
}

package Pkg::VRTSvcsk731::AIX;
@Pkg::VRTSvcsk731::AIX::ISA = qw(Pkg::VRTSvcsk731::Common);

sub init_plat {
    my $pkg=shift;
    $pkg->{donotrmonupgrade}=1;
    return;
}

package Pkg::VRTSvcsk731::HPUX;
@Pkg::VRTSvcsk731::HPUX::ISA = qw(Pkg::VRTSvcsk731::Common);

sub init_plat {
    my $pkg=shift;
    $pkg->{donotrmonupgrade}=1;
    return;
}

package Pkg::VRTSvcsk731::Linux;
@Pkg::VRTSvcsk731::Linux::ISA = qw(Pkg::VRTSvcsk731::Common);

sub init_padv {
    my $pkg = shift;
    $pkg->{iopt}='--replacefiles' if (Obj::rel()->{simple});
    return;
}

package Pkg::VRTSvcsk731::SunOS;
@Pkg::VRTSvcsk731::SunOS::ISA = qw(Pkg::VRTSvcsk731::Common);

sub init_plat {
    my $pkg=shift;
    $pkg->{donotrmonupgrade}=1;
    return;
}

1;
