#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
use strict;

package Pkg::VRTSvlic32::Common;
@Pkg::VRTSvlic32::Common::ISA = qw(Pkg);

sub init_common {
    my $pkg=shift;
    $pkg->{pkg}='VRTSvlic';
    $pkg->{name}=Msg::new("Licensing")->{msg};
    $pkg->{gavers}='3.2.71.3';
    return;
}

#Add dependency for other products only when uninstall VRTSvlic
sub query_pkgdep_sys {
    my ($pkg,$sys)=@_;
    my (@softdeps,$vxvm,$vxfs,$vcs,$rel);
    $rel=Obj::rel();
    if (Cfg::opt('uninstall')) {
	$vxvm = $sys->pkg('VRTSvxvm731') if (EDRu::inarr("VM731",@{$rel->{prods}}));
	$vxfs = $sys->pkg('VRTSvxfs731') if (EDRu::inarr("FS731",@{$rel->{prods}}));
	$vcs = $sys->pkg('VRTSvcs731') if (EDRu::inarr("VCS731",@{$rel->{prods}}));
        push (@softdeps, $vxvm->{pkg}) if ($vxvm && $vxvm->version_sys($sys));
        push (@softdeps, $vxfs->{pkg}) if ($vxfs && $vxfs->version_sys($sys));
        push (@softdeps, $vcs->{pkg}) if ($vcs && $vcs->version_sys($sys));
        return \@softdeps;
    }
    return [];
}

package Pkg::VRTSvlic32::AIX;
@Pkg::VRTSvlic32::AIX::ISA = qw(Pkg::VRTSvlic32::Common);

sub init_plat {
    my $pkg=shift;
    $pkg->{donotrmonupgrade}=1;
    return;
}

package Pkg::VRTSvlic32::HPUX;
@Pkg::VRTSvlic32::HPUX::ISA = qw(Pkg::VRTSvlic32::Common);

package Pkg::VRTSvlic32::Linux;
@Pkg::VRTSvlic32::Linux::ISA = qw(Pkg::VRTSvlic32::Common);

package Pkg::VRTSvlic32::SunOS;
@Pkg::VRTSvlic32::SunOS::ISA = qw(Pkg::VRTSvlic32::Common);

1;
