#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
use strict;

package Proc::CmdServer731::Common;
@Proc::CmdServer731::Common::ISA = qw(Proc);

sub init_common {
    my $proc=shift;
    $proc->{proc}='CmdServer';
    $proc->{name}='Command Server';
    $proc->{desc}='CmdServer description';
    $proc->{controlfile}='/opt/VRTSvcs/bin/CmdServer';
    $proc->{stop_period}=10;
    return;
}

sub start_sys {
    my ($proc,$sys)=@_;
    $sys->cmd("$proc->{controlfile}");
    return 1;
}

sub stop_sys {
    my ($proc,$sys)=@_;
    $sys->cmd("$proc->{controlfile} -stop");
    return 1;
}

sub check_sys {
    my ($proc,$sys)=@_;
    my $pids=$sys->proc_pids('bin/CmdServer');
    if ($#$pids == -1) {
        return 0;
    }
    return 1;
}

sub force_stop_sys {
    my ($proc,$sys)=@_;
    my $pids=$sys->proc_pids('bin/CmdServer');
    # kill CmdServer
    $sys->kill_pids(@$pids);
    return 1;
}

sub start_failed_sys {
    my ($proc,$sys)=@_;

    Msg::log("## Check start failures in CmdServer-log_A.log:\n");
    $sys->cmd("_cmd_tail -10 $sys->{vcs_log_path}/log/CmdServer-log_A.log 2>/dev/null");
    return 1;
}

sub stop_failed_sys {
    my ($proc,$sys)=@_;

    Msg::log("## Check stop failures in CmdServer-log_A.log:\n");
    $sys->cmd("_cmd_tail -10 $sys->{vcs_log_path}/log/CmdServer-log_A.log 2>/dev/null");
    return 1;
}

package Proc::CmdServer731::AIX;
@Proc::CmdServer731::AIX::ISA = qw(Proc::CmdServer731::Common);

package Proc::CmdServer731::HPUX;
@Proc::CmdServer731::HPUX::ISA = qw(Proc::CmdServer731::Common);

package Proc::CmdServer731::Linux;
@Proc::CmdServer731::Linux::ISA = qw(Proc::CmdServer731::Common);

package Proc::CmdServer731::SunOS;
@Proc::CmdServer731::SunOS::ISA = qw(Proc::CmdServer731::Common);

1;
