#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
use strict;

package Proc::fdd731::Common;
@Proc::fdd731::Common::ISA = qw(Proc);

sub init_common {
    my $proc=shift;
    $proc->{proc}='fdd';
    $proc->{name}='fdd name';
    $proc->{desc}='fdd description';
    return;
}

package Proc::fdd731::AIX;
@Proc::fdd731::AIX::ISA = qw(Proc::fdd731::Common);

package Proc::fdd731::HPUX;
@Proc::fdd731::HPUX::ISA = qw(Proc::fdd731::Common);

package Proc::fdd731::Linux;
@Proc::fdd731::Linux::ISA = qw(Proc::fdd731::Common);

# load to kernel
sub start_sys {
    my ($proc,$sys)=@_;
    $sys->load_driver($proc->{proc});
    return 1;
}

# unload from kernel
sub stop_sys {
    my ($proc,$sys)=@_;
    $sys->unload_driver($proc->{proc});
    return 1;
}

# check whether mod is loaded
# 1 means loaded, 0 means not loaded
sub check_sys {
    my ($proc,$sys)=@_;
    my $rtn=$sys->get_drivers($proc->{proc});
    return ($rtn?1:0);
}

package Proc::fdd731::SunOS;
@Proc::fdd731::SunOS::ISA = qw(Proc::fdd731::Common);

# load to kernel
sub start_sys {
    my ($proc,$sys)=@_;
    $sys->load_driver($proc->{proc});
    return 1;
}

# check whether mod is loaded
# 1 means loaded, 0 means not loaded
sub check_sys {
    my ($proc,$sys)=@_;
    my $rtn=$sys->get_drivers($proc->{proc});
    return ($rtn?1:0);
}

# unload from kernel
sub stop_sys {
    my ($proc,$sys)=@_;
    my ($mod,$cmd,$driver);
    $driver=$proc->{proc};
    $sys->cmd('echo vxfdd_nounload/W0 | _cmd_adb -k -w > /dev/null 2>&1');
    $mod=$sys->get_drivers( $driver);
    if ($mod) {
        # To avoid Solaris 11/12 aggressive module auto load mechanism
        $cmd="_cmd_rmdrv $driver 2>/dev/null";
        for my $mod_id (split(/\s+/m,$mod)) {
            $cmd.=";_cmd_modunload -i $mod_id 2>/dev/null";
        }
        $sys->cmd("$cmd");
    }

    return 1;
}

1;
