#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
use strict;

package Proc::vxcpserv731::Common;
@Proc::vxcpserv731::Common::ISA = qw(Proc);

sub init_common {
    my $proc=shift;
    $proc->{proc}='vxcpserv';
    $proc->{name}='vxcpserv';
    $proc->{desc}='vxcpserv description';
    $proc->{cpsadm}='/opt/VRTS/bin/cpsadm';
    $proc->{stop_period}=10;
    return;
}

sub check_sys {
    my ($proc,$sys,$state)=@_;
    my $pids=$sys->proc_pids('bin/vxcpserv');
    if ($#$pids == -1) {
        Msg::log("vxcpserv is not running on $sys->{sys}.");
        return 0;
    }
    return 1;
}

sub start_sys {
    my ($proc,$sys)=@_;
    return 1;
}

sub stop_sys {
    my ($proc,$sys) = @_;
    my ($vcs,$had,$sysname);
    $had=$proc->proc('had731');
    $vcs=$proc->prod('VCS731');
    $sysname = $sys->{vcs_sysname};
    $sysname ||= $vcs->get_vcs_sysname_sys($sys);
    if ($had->check_sys($sys, 'start')) {
        $sys->cmd("$vcs->{bindir}/hagrp -offline CPSSG -sys $sysname");
    } else {
        $sys->cmd("$proc->{cpsadm} -s $sysname -a halt_cps");
    }
    return 1;
}

sub force_stop_sys {
    my ($proc,$sys) = @_;
    my ($pids,$proc_name);
    $proc_name='bin/vxcpserv';
    $pids=$sys->proc_pids($proc_name);
    $sys->kill_pids(@$pids);
    return 1;
}

package Proc::vxcpserv731::AIX;
@Proc::vxcpserv731::AIX::ISA = qw(Proc::vxcpserv731::Common);

package Proc::vxcpserv731::HPUX;
@Proc::vxcpserv731::HPUX::ISA = qw(Proc::vxcpserv731::Common);

package Proc::vxcpserv731::Linux;
@Proc::vxcpserv731::Linux::ISA = qw(Proc::vxcpserv731::Common);

package Proc::vxcpserv731::SunOS;
@Proc::vxcpserv731::SunOS::ISA = qw(Proc::vxcpserv731::Common);

1;
