#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
use strict;

package Proc::vxgin731::Common;
@Proc::vxgin731::Common::ISA = qw(Proc);

sub init_common {
    my $proc=shift;
    $proc->{proc}='vxgin';
    $proc->{name}='vxgin name';
    $proc->{desc}='vxgin description';
    $proc->{fatal}=1;
    return;
}

sub start_sys {
    return 1;
}

sub stop_sys {
    return 1;
}

package Proc::vxgin731::Linux;
@Proc::vxgin731::Linux::ISA = qw(Proc::vxgin731::Common);

package Proc::vxgin731::RHEL7x8664;
@Proc::vxgin731::RHEL7x8664::ISA = qw(Proc::vxgin731::Linux);

sub start_sys {
    my ($proc,$sys)=@_;
    $sys->cmd("_cmd_rm -rf /etc/systemd/system/multi-user.target.wants/vxgin.service");
    $sys->cmd("_cmd_ln -s /usr/lib/systemd/system/vxgin.service /etc/systemd/system/multi-user.target.wants/vxgin.service");
    $sys->cmd("/usr/bin/systemctl enable vxgin 2>/dev/null");
    $sys->cmd("/usr/bin/systemctl start vxgin 2>/dev/null");
    return 1;
}

sub stop_sys {
    my ($proc,$sys)=@_;
    $sys->cmd("/usr/bin/systemctl stop vxgin 2>/dev/null");
    if (Cfg::opt('uninstall')) {
        $sys->cmd("/usr/bin/systemctl disable vxgin 2>/dev/null");
    }
    return 1;
}

sub check_sys {
    my ($proc,$sys,$status,$msg)=@_;
    $status=$sys->cmd("/usr/bin/systemctl status vxgin 2>/dev/null | _cmd_grep 'Active:'");
    return 1 if ($status =~ /running/);

    return 0;
}

sub start_failed_sys {
    return 1;
}

sub stop_failed_sys {
    return 1;
}

1;
