#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
use strict;

package Proc::vxnotify731::Common;
@Proc::vxnotify731::Common::ISA = qw(Proc);

sub init_common {
    my $proc=shift;
    $proc->{proc}='vxnotify';
    $proc->{name}='vxnotify name';
    $proc->{desc}='vxnotify description';
    return;
}

sub stop_sys {
    my ($proc,$sys)=@_;

    #Check sfmh-discovery status before stopping vxnotify
    my $cpic=Obj::cpic();
    my $procobj=$sys->proc('sfmhdiscovery731');
    if($procobj && $procobj->check_sys($sys,"stop")){
        Msg::log("Stopping sfmh-discovery before vxnotify ");
        $procobj->stop_sys($sys);
        sleep 1;
     } else {
        Msg::log("sfmh-discovery is not running when stopping vxnotify");
     }

    my $pids=$sys->proc_pids($proc->{proc});
    $sys->kill_pids(@$pids);
    return 1;
}

sub check_sys {
    my ($proc,$sys)=@_;
    my $pids=$sys->proc_pids($proc->{proc});
    if ($#$pids == -1) {
        return 0;
    }
    return 1;
}

package Proc::vxnotify731::AIX;
@Proc::vxnotify731::AIX::ISA = qw(Proc::vxnotify731::Common);

package Proc::vxnotify731::HPUX;
@Proc::vxnotify731::HPUX::ISA = qw(Proc::vxnotify731::Common);

package Proc::vxnotify731::Linux;
@Proc::vxnotify731::Linux::ISA = qw(Proc::vxnotify731::Common);

package Proc::vxnotify731::SunOS;
@Proc::vxnotify731::SunOS::ISA = qw(Proc::vxnotify731::Common);

1;
