#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#
use strict;

package Proc::xprtld731::Common;
@Proc::xprtld731::Common::ISA = qw(Proc);

sub init_common {
    my $proc=shift;
    $proc->{proc}='xprtld';
    $proc->{name}='xprtld';
    $proc->{desc}='xprtld description';
    $proc->{xprtldctrl}='/opt/VRTSsfmh/adm/xprtldctrl';
    return;
}

sub check_sys {
    my ($proc,$sys,$state)=@_;
    my $pids=$sys->proc_pids('/opt/VRTSsfmh/bin/xprtld');
    if ($#$pids == -1) {
        return 0;
    }
    return 1;
}

sub start_sys {
    my ($proc,$sys)=@_;
    my ($pids);
    $pids = $sys->proc_pids('/opt/VRTSsfmh/bin/xprtld');
    unless ((defined $pids) && @$pids) {
        $sys->cmd("$proc->{xprtldctrl} start 2> /dev/null");
    }
    return 1;
}

sub stop_sys {
    my ($proc,$sys)=@_;
    if ($sys->exists("$proc->{xprtldctrl}")) {
        $sys->cmd("$proc->{xprtldctrl} stop");
    }
    return 1;
}

sub force_stop_sys {
    my ($proc,$sys) = @_;
    my ($pids);
    $pids=$sys->proc_pids('/opt/VRTSsfmh/bin/xprtld');
    $sys->kill_pids(@$pids);
    return 1;
}

package Proc::xprtld731::AIX;
@Proc::xprtld731::AIX::ISA = qw(Proc::xprtld731::Common);

package Proc::xprtld731::HPUX;
@Proc::xprtld731::HPUX::ISA = qw(Proc::xprtld731::Common);

package Proc::xprtld731::Linux;
@Proc::xprtld731::Linux::ISA = qw(Proc::xprtld731::Common);

package Proc::xprtld731::SunOS;
@Proc::xprtld731::SunOS::ISA = qw(Proc::xprtld731::Common);

1;
