#
# VT50-2000-2016-84-28-4
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
# 


use strict;

use EDR;
use CPIC;

use Rel::UXRT731;
require "Rel/Releasedefs.pl";
require "Rel/UXRTLicensing731.pl";

use Prod::DMP731;
use Prod::FS731;
use Prod::SF731;
use Prod::SFHA731;
use Prod::SFCFS731;
use Prod::SFCFSHA731;
use Prod::SFCFSRAC731;
use Prod::SFRAC731;
use Prod::SVS731;
use Prod::VCS731;
use Prod::VM731;
use Prod::LP731;
use Prod::SFSYBASECE731;
use Prod::APPLICATIONHA731;
use Prod::ENTERPRISE731;
use Prod::STORAGE731;
use Prod::AVAILABILITY731;
use Prod::FOUNDATION731;


use Pkg::VRTSacclib52;
use Pkg::VRTSamf731;
use Pkg::VRTSaslapm731;
use Pkg::VRTSat50;
use Pkg::VRTSatClient50;
use Pkg::VRTScavf731;
use Pkg::VRTScps731;
use Pkg::VRTSdbac731;
use Pkg::VRTSdbed731;
use Pkg::VRTSfsadv731;
use Pkg::VRTSfssdk731;
use Pkg::VRTSgab731;
use Pkg::VRTSglm731;
use Pkg::VRTSgms731;
use Pkg::VRTSllt731;
use Pkg::VRTSob34;
use Pkg::VRTSodm731;
use Pkg::VRTSperl520;
use Pkg::VRTSpython35;
use Pkg::VRTSsfmh731;
use Pkg::VRTSsfcpi731;
use Pkg::VRTSspt731;
use Pkg::VRTSsvs731;
use Pkg::VRTSvcs731;
use Pkg::VRTSvcsag731;
use Pkg::VRTSvcsea731;
use Pkg::VRTSveki731;
use Pkg::VRTSvlic32;
use Pkg::VRTSvxfen731;
use Pkg::VRTSvxfs731;
use Pkg::VRTSvxvm731;
use Pkg::VRTSlang731;
use Pkg::VRTSvbs731;
use Pkg::VRTSvcswiz731;
use Pkg::VRTSvcsvmw731;
use Pkg::VRTSinfr731;
use Pkg::VRTSvcsk731;
use Pkg::VRTSvcsa731;
use Pkg::VRTScfs731;

use Proc::amf731;
use Proc::CmdServer731;
use Proc::fdd731;
use Proc::gab731;
use Proc::had731;
use Proc::veki731;
use Proc::llt731;
use Proc::lmx731;
use Proc::odm731;
use Proc::qio731;
use Proc::qlog731;
use Proc::sfmhdiscovery731;
use Proc::vcsmm731;
use Proc::vvr731;
use Proc::vxattachd731;
use Proc::vxatd50;
use Proc::vxcached731;
use Proc::vxconfigbackupd731;
use Proc::vxconfigd731;
use Proc::vxcpserv731;
use Proc::vxdclid50;
use Proc::vxdclid731;
use Proc::vxdbd731;
use Proc::vxdmp731;
use Proc::vxesd731;
use Proc::vxfen731;
use Proc::vxfs731;
use Proc::vxglm731;
use Proc::vxgms731;
use Proc::vxio731;
use Proc::vxnotify731;
use Proc::vxpal50;
use Proc::vxportal731;
use Proc::vxrelocd731;
use Proc::vxsited731;
use Proc::vxspec731;
use Proc::vxsvc34;
use Proc::xprtld731;
use Proc::svsweb731;
use Proc::vxcafs731;
use Proc::vxgin731;
use Proc::vxcfsplugin731;
use Proc::vxvvrstatd731;
use Proc::vxencryptd731;
use Proc::vxlogger731;
use Proc::vxvollogd731;
use Proc::vxrecover731;
use Proc::vxcloud731;

package CPIP;

sub cpip_resume_subs {
    [ qw(Prod::SFRAC731::Common::cli_prestart_config_questions
         Prod::SFRAC731::Common::config_sfrac_subcomponents
         Prod::SFRAC731::Common::create_oracle_user_group
         Prod::SFRAC731::Common::create_ocr_vote_storage
         Prod::SFRAC731::Common::install_oracle_clusterware
         Prod::SFRAC731::Common::install_oracle_database
         Prod::SFRAC731::Common::config_cssd_agent
         Prod::SFRAC731::Common::relink_oracle_database
         Prod::SFRAC731::Common::post_config_check_sfrac
         Prod::SFRAC731::Common::config_haip
         Prod::SFRAC731::Common::config_privnic
         Prod::SFRAC731::Common::config_multiprivnic
         Prod::SFCFSHA731::Common::cli_prestart_config_questions
         Prod::SFSYBASECE731::Common::cli_prestart_config_questions
         Prod::VCS731::Common::add_users
         Prod::VCS731::Common::ask_clustername
         Prod::VCS731::Common::ask_fencing_enabled
         Prod::VCS731::Common::ask_hbnics
         Prod::VCS731::Common::autocfg_hbnics
         Prod::VCS731::Common::cli_prestart_config_questions
         Prod::VCS731::Common::config_cluster
         Prod::VCS731::Common::config_gcoption
         Prod::VCS731::Common::config_smtp
         Prod::VCS731::Common::config_snmp
         Prod::VCS731::Common::config_vip
         Prod::VCS731::Common::config_vxss
         Prod::VCS731::Common::hb_config_option
         Prod::VCS731::Common::set_lowpri_for_slow_links
         Prod::VM731::AIX::cli_prestart_config_questions
         Prod::VM731::HPUX::cli_prestart_config_questions
         Prod::VM731::Linux::cli_prestart_config_questions
         Prod::VM731::SunOS::ask_upgrade_err_sys
         Prod::VM731::SunOS::cli_prestart_config_questions
    ) ]
}

sub get_hotfix_sort_url {
    my $url;
    $url="https://sort.veritas.com/vos_services/rest/patch_services/1.0/release";
    return $url;
}

sub get_kernel_padv_sort_url {
    my $url;
    $url="http://sort.veritas.com/SORTServices/rest/matrix/1.0/padvmatrix?&source=cpi";
    return $url;
}

sub get_release_version {
    my ($release) = @_;

    my $self = {};
    my $class ="Rel\::$release\::Common";
    bless($self, $class);
    $self->{class} = $class;
    $self->init();
    return $self->{titlevers};
}

Trace::binding(CPIP::traceconf());

1;
