package Macros;
use strict;

our $macros=Macros->new();

sub new {
    my $class = shift;
    my $self  = {};
    bless($self, $class);
    $self->init_module_ids();
    $self->init_module_macros();
    return $self;
}

sub init_module_ids {
    my $self=shift;
    $self->{id}{LLT}=1;
    $self->{id}{GAB}=2;
    $self->{id}{AMF}=3;
    $self->{id}{VXFEN}=4;
    $self->{id}{VCS}=5;
    $self->{id}{GMS}=6;
    $self->{id}{ODM}=7;
    $self->{id}{SFCFSHA}=8;
    return;
}

sub init_module_macros {
    my $self=shift;
    $self->set("VERITAS_LLT_SUCCESS",0);
    $self->set("VERITAS_GAB_SUCCESS",0);
    return;
}

sub set {
    my ($self,$key,$value)=@_;
    my @keys=split('_',$key);
    # Assume all the macros have the following pattern:
    # Class_Module_State
    my $id=$self->{id}{$keys[1]};
    if ($id) {
        $self->{$key}=($id<<8) + $value;
    } else {
        return 1;
    }
    return 0;
}

1;
