#
# $Copyright: Copyright (c) 2018 Veritas Technologies LLC. All rights reserved.
# 
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF VERITAS
# TECHNOLOGIES LLC.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE
# PRIOR EXPRESS WRITTEN PERMISSION OF VERITAS TECHNOLOGIES LLC.
# 
# The Licensed Software  and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software  -  Restricted Rights"
# and DFARS 227.7202,  Rights  in  "Commercial Computer Software or  Commercial
# Computer Software Documentation" as applicable, and any successor regulations,
# whether  delivered  by  Veritas  as  on premises or hosted services.  Any use,
# modification, reproduction release, performance, display or disclosure of the
# Licensed Software and Documentation by the U.S. Government shall be solely in
# accordance with the terms of this Agreement. $
#

package Module::facter::software;

# Get the following facts for software
#    os_packages
#    os_patches


package Module::facter::software::Linux;

sub execute_sys {
    my ($self,$sys) = @_;
    my ($facts,$rc,$output,$os_packages);

    $facts={};

    # get basic OS packages
    #($rc,$output)=$sys->cmd("/bin/rpm -qa 2>/dev/null");
    if (!$rc && $output) {
        $os_packages='';
        for my $line (split(/\n+/,$output)) {
            # kick off those extra packages, like docs, l10n, fonts, desktop packages
            next if ($line=~/^(gtk|php|Py|py|libX|xorg|gnome|kde|qt|m17n|xml|mesa|VRTS|SYMC)/);
            next if ($line=~/(devel|lang|l10n|gnome|gtk|desktop|python|emacs|eclipse|firmware|fonts|docs)/);
            $os_packages.="$line ";
        }
        $os_packages=~s/\s*$//;
        $facts->{os_packages} = $os_packages;
    }

    return $facts;
}

package Module::facter::software::SunOS;

sub execute_sys {
    my ($self,$sys) = @_;
    my ($facts);

    $facts={};

    return $facts;
}

package Module::facter::software::AIX;

sub execute_sys {
    my ($self,$sys) = @_;
    my ($facts);

    $facts={};

    return $facts;
}

package Module::facter::software::HPUX;

sub execute_sys {
    my ($self,$sys) = @_;
    my ($facts);

    $facts={};

    return $facts;
}

1;
