package Module::veritas::gms;

#description
#	- Manage GMS config file
#options:
#	state:
#		default: "absent"
#		choices: [ present, absent ]
#		description: Set GMS_START=1 or 0 in /etc/vx/gms.config.
#

$Macros::macros->set("VERITAS_GMS_SUCCESS",0);

sub execute_sys {                                                                                                
    my ($self,$sys,$attrs) = @_;
    my ($return,$state);
	my ($conf_file,$pre_state,$rc,$output,$cmd);
	
	$return={ 'changed' => 0 ,'rc'=>0};

	return $return if (!defined $attrs);

	$attrs=eval($attrs) if ref($attrs) eq '';
	
	$state=$attrs->{state} || 'absent';
	if ( $state eq 'present' and $attrs->{component} =~ /sfcfs|sfrac/i ) {
		$state=1;
	} else {
		$state=0;
	}

	$conf_file = "/etc/vx/gms.config";
	$pre_state = 0;
	if(-e $conf_file){
		$cmd="_cmd_cat $conf_file | _cmd_grep 'GMS_START=1'";
		($rc, $output)=$sys->cmd("$cmd 2>/dev/null");
		$pre_state = 1 unless $rc; 
	}else{
		$pre_state = !$state
	}

	if ( $state xor $pre_state ){
		$cmd="_cmd_echo 'GMS_START=$state' > $conf_file";
		($rc, $output)=$sys->cmd("$cmd 2>/dev/null");
		$return->{changed} = 1 unless $rc;
	} 

    $return->{rc} = $macros->{VERITAS_GMS_SUCCESS} unless $return->{rc};
	return $return;

}

1;
