package Module::veritas::odm;

# description:
#     - enable/disable odm process 
# options:
#     state:
#         required: false
#         default: "present"
#         choices: [ present, absent ]
#         description:
#             - Whether the odm process should be enabled or disabled

$Macros::macros->set("VERITAS_ODM_SUCCESS",0);
$Macros::macros->set("VERITAS_ODM_NO_CONF",1);

sub execute_sys {
    my ($self,$sys,$attrs) = @_;
    my ($return,$state,$status,$rc,$output,$conf_file);
    $return={ 'changed' => 0 ,'rc'=>0};
    return $return if (!defined $attrs);
	$attrs=eval($attrs) if ref($attrs) eq '';
    $state=$attrs->{state} || 'present';
    $conf_file="/etc/vx/odm.config";
    unless ($sys->exists($conf_file)){
        $sys->log("The ODM configuration file not exist","error");
        $return->{rc}=$macros->{VERITAS_ODM_NO_CONF};
        return $return;
    }    
    $rc=init_config_file($sys,$conf_file);
    if($state eq "present" and $attrs->{component} =~ /sfha|sfcfs|sfrac/i ){
    	$sys->cmd("_cmd_sed -i \"s/^ODM_START=.*\$/ODM_START=1/\" $conf_file");
        $return->{changed}=1 if($rc!=1);
    }else{
    	$sys->cmd("_cmd_sed -i \"s/^ODM_START=.*\$/ODM_START=0/\" $conf_file");
        $return->{changed}=1 if($rc!=0);
    }     
    $return->{rc}=$macros->{VERITAS_ODM_SUCCESS} unless $return->{rc};
    return $return;
}

sub init_config_file{
    my ($sys,$file)=@_;
    my $conf=$sys->cmd("_cmd_cat $file");
    if($conf =~ /ODM_START=0/mx){
        return 0;
    }elsif($conf =~ /ODM_START=1/mx){
 	return 1
    }else{
        $sys->cmd("_cmd_echo 'ODM_START=0' >>$file");
	return -1;
    }
}

1;
