package Template;
@Template::ISA = qw(Obj);

use strict;

our $DO_CHOMP = 0;
our $BE_LOCAL = 1;

sub parse {
    my $self=shift;
    my $data = shift;

    my $vars = {};
    if ( ref( $_[0] ) eq "HASH" ) {
        $vars = shift;
    } else {
        $vars = {@_};
    }

    my $new_data;
    my $___r = "";

    my $do_chomp = 0;
    $new_data = join(
        "\n",
        map {
            my ( $code, $type, $text ) = ( $_ =~ m/(\<%)*([+=])*(.+)%\>/s );

            if ($code) {
                my $pcmd = substr( $text, -1 );
                if ( $pcmd eq "-" ) {
                    $text = substr( $text, 0, -1 );
                    $do_chomp = 1;
                }

                my ( $var_type, $var_name ) = ( $text =~ m/([\$])::([a-zA-Z0-9_]+)/ );

                if ( $var_name && !ref( $vars->{$var_name} ) && !$BE_LOCAL ) {
                      $text =~ s/([\$])::([a-zA-Z0-9_]+)/$1\{\$$2\}/g;
                } elsif ( $var_name && !ref( $vars->{$var_name} ) && $BE_LOCAL ) {
                      $text =~ s/([\$])::([a-zA-Z0-9_]+)/$1$2/g;
                } else {
                      $text =~ s/([\$])::([a-zA-Z0-9_]+)/\$$2/g;
                }

                if ( $type && $type =~ m/^[+=]$/ ) {
                    "\$___r .= $text;";
                } else {
                    $text;
                }

            } else {
                my $chomped = $_;
                if ( $DO_CHOMP || $do_chomp ) {
                    chomp $chomped;
                    $do_chomp = 0;
                }
                '$___r .= "' . EDRu::escape($chomped) . '";';

            }

        } split( /(\<%.*?%\>)/s, $data )
    );

    eval {
        no strict 'refs';
        no strict 'vars';

        for my $var ( keys %{$vars} ) {
            Msg::debug("Registering: $var");
            unless ( ref( $vars->{$var} ) ) {
                $$var = \$vars->{$var};
            } else {
                $$var = $vars->{$var};
            }
        }

        if ( $BE_LOCAL == 1 ) {
            my $var_data = '
      
                return sub {
                    my $___r = "";
                    my (
          
                ';

            my @code_values;
            for my $var ( keys %{$vars} ) {
                my $new_var = EDRu::normalize_var_name($var);
                Msg::debug("Registering local: $new_var");
                $var_data .= '$' . $new_var . ", \n";
                push( @code_values, $vars->{$var} );
            }

            $var_data .= '$this_is_really_nothing) = @_;';
            $var_data .= "\n";

            $var_data .= $new_data;

            $var_data .= "\n";
            $var_data .= ' return $___r;';
            $var_data .= "\n};";

            Msg::debug("BE_LOCAL==1");

            my %args = ();
            if ( defined $args{'d'} && $args{'d'} > 1 ) {
                Msg::debug($var_data);
            }

            my $tpl_code = eval($var_data);

            if ($@) {
                Msg::debug($@);
            }

            $___r = $tpl_code->(@code_values);

        } else {
            Msg::debug("BE_LOCAL==0");
            #my %args = getopts;
            #if ( defined $args{'d'} && $args{'d'} > 1 ) {
            #    Msg::debug($new_data);
            #}

            $___r = eval($new_data);

            if ($@) {
                Msg::debug($@);
            }
        }

        # undef the vars
        for my $var ( keys %{$vars} ) {
            $$var = undef;
        }

    };

    if ( !$___r ) {
        Msg::debug("It seems that there was an error processing the template, because the result is empty");
        Msg::die("Error processing template");
    }

    return $___r;
}

1;
